# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define _with_repolib 1

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/jboss/aop/1.5.5.GA-brew
%define repodirlib %{repodir}/lib
%define repodirres %{repodir}/resources
%define repodirsrc %{repodir}/src

# If you want to built without jdk15 support, 
# give rpmbuild option '--without jdk15'
%define without_jdk15 %{?_without_jdk15:1}%{!?_without_jdk15:0}
%define with_jdk15 %{!?_without_jdk15:1}%{?_without_jdk15:0}

%define section  free

Summary:        JBoss AOP Framework
Name:           jboss-aop
Version:        1.5.5
Release:        0jpp.ep1.2%{?dist}.1
Epoch:          0
License:        LGPL
Group:          Internet/WWW/Servers
URL:            http://www.jboss.org/
# cvs -d:pserver:anonymous@anoncvs.forge.jboss.com:/cvsroot/jboss export -r JBoss_AOP_1_5_5 jboss-aop
Source0:        jboss-aop-1.5.5.GA-src.tgz
Source1:	    jboss-aop-component-info.xml

Source2:        %{name}-%{version}-apache-jaxme-component-info.xml
Source3:        %{name}-%{version}-apache-logging-component-info.xml

Patch0:		    %{name}-%{version}-scripts.patch
Patch1:         %{name}-%{version}-disable-license-fetching.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:      noarch
# general requires
BuildRequires: jpackage-utils >= 0:1.6
BuildRequires: ant >= 0:1.6.2
BuildRequires: ant-nodeps >= 0:1.6.2
#BuildRequires:       jboss4-buildmagic-tasks
%if %{with_jdk15}
BuildRequires: java-1.5.0-bea-devel
BuildRequires: java-1.5.0-bea
%else
BuildRequires: java-1.4.2-bea-devel
BuildRequires: java-1.4.2-bea
%endif

BuildRequires: concurrent-repolib
BuildRequires: dom4j-repolib
BuildRequires: dtdparser-repolib
BuildRequires: gnu-trove-repolib
BuildRequires: jakarta-commons-codec-repolib
BuildRequires: jakarta-commons-httpclient-repolib
BuildRequires: jakarta-commons-logging
BuildRequires: jakarta-slide-webdavclient-repolib
BuildRequires: javassist-repolib
BuildRequires: jboss-profiler-jvmti-repolib
BuildRequires: junit-repolib
BuildRequires: log4j-repolib
BuildRequires: qdox-repolib
BuildRequires: quartz-repolib
BuildRequires: snmptrapappender-repolib
BuildRequires: ws-jaxme
BuildRequires: xalan-j2-repolib
BuildRequires: xdoclet-repolib
BuildRequires: xerces-j2-repolib
BuildRequires: xml-commons-repolib

Obsoletes:     jboss-aop-framework

Requires:      gnu-trove
Requires:      javassist >= 0:3.1
Requires:      jboss-common
Requires:      qdox >= 0:1.5

%description
JBoss AOP is a 100% Pure Java aspected oriented framework 
usuable in any programming environment or tightly integrated 
with our application server. Aspects allow you to more easily 
modularize your code base when regular object oriented 
programming just doesn't fit the bill. It can provide a 
cleaner separation from application logic and system code. 
It provides a great way to expose integration points into 
your software. Combined with JDK 1.5 Annotations, it also 
is a great way to expand the Java language in a clean 
pluggable way rather than using annotations solely for 
code generation. 


%if %{with_repolib}
%package	 repolib
Summary:	 Artifacts to be uploaded to a repository library
Group:	Development/Libraries/Java

%description	 repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
%{summary}.

%package        manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description    manual
%{summary}.

%prep
%setup -qq -n jboss-aop-%{version}-src

%patch0 -b .sav
%patch1 -b .sav

# Build thirdparty
mkdir thirdpartyrepo

# No need to guess this list when dependencies change. Just make it do 
# for item in javadir/repository.jboss..../* 
# and then do a build, see what ends up in thirdparty/
for item in apache-codec apache-httpclient apache-log4j apache-slide \
            apache-xalan apache-xerces apache-xml-commons dom4j javassist \
            jboss/profiler/jvmti junit oswego-concurrent qdox quartz \
            snmptrapappender trove wutka-dtdparser xdoclet; do

    target=thirdpartyrepo/
    if [ "`dirname $item`" != "." ]; then
        target=$target/`dirname $item`
    fi

    mkdir -p $target
    cp -r %{_javadir}/repository.jboss.com/$item $target

done

# Synchronize versions. We want to use the versions on the system -- update b-t.xml for it
for dir in `find thirdpartyrepo -type d -name lib`; do
    depversion=`basename \`dirname $dir\``
    depname=`echo $dir | sed -e s:thirdpartyrepo/::g -e s:/$depversion/lib::g`

    sed -i -e s:"<componentref name=\"$depname\" version=\".*\"/>":"<componentref name=\"$depname\" version=\"$depversion\"/>":g build/build-thirdparty.xml
done

# Whatever we don't have a repolib for, we manually copy over for now

# JaxMe
mkdir -p thirdpartyrepo/apache-jaxme/0.2-cvs/lib
ln -sf $(build-classpath jaxme/jaxmexs) thirdpartyrepo/apache-jaxme/0.2-cvs/lib/
cp %{SOURCE2} thirdpartyrepo/apache-jaxme/0.2-cvs/component-info.xml

# commons-logging
mkdir -p thirdpartyrepo/apache-logging/1.0.5.GA-jboss/lib
ln -sf $(build-classpath jakarta-commons-logging) thirdpartyrepo/apache-logging/1.0.5.GA-jboss/lib/commons-logging.jar
cp %{SOURCE3} thirdpartyrepo/apache-logging/1.0.5.GA-jboss/component-info.xml

ant -f build/build.xml -Djbossbuild.repository=file://`pwd`/thirdpartyrepo createthirdparty


tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE1}

%build

BUILD_ID=`date -u +%Y%m%d%H%M`_%{version}-%{release}

export CLASSPATH=""
export JROCKITHOME=""
%if %{with_jdk15}
export JAVA_HOME=/usr/lib/jvm/java-1.5.0
rpm -q --whatprovides java-1.5.0-bea && JROCKITHOME=%{_jvmdir}/java-1.5.0-bea
%else
export JAVA_HOME=/usr/lib/jvm/java-1.4.2
rpm -q --whatprovides java-1.4.2-bea && JROCKITHOME=%{_jvmdir}/java-1.4.2-bea
%endif

ant -f build/build.xml -Djrockit.home=${JROCKITHOME} all

%install
rm -rf $RPM_BUILD_ROOT

install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}

# install aop framework
install -m 644 aop/output/lib/jboss-aop.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-aop-%{version}.jar
install -m 644 aop/output/lib/jdk14-pluggable-instrumentor.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jdk14-pluggable-instrumentor-%{version}.jar
[ -f aop/output/lib/jrockit-pluggable-instrumentor.jar ] && install -m 644 aop/output/lib/jrockit-pluggable-instrumentor.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jrockit-pluggable-instrumentor-%{version}.jar
%if %{with_jdk15}
install -m 644 aop/output/lib/jboss-aop-jdk50.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-aop-jdk50-%{version}.jar
install -m 644 aop/output/lib/pluggable-instrumentor.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/pluggable-instrumentor-%{version}.jar
install -m 644 aop/output/lib/jboss-aop-jdk50-client.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-aop-jdk50-client-%{version}.jar
%endif

# create all versionless symlinks
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# bin
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/bin
install -m 755 aop/src/resources/bin/*.sh $RPM_BUILD_ROOT%{_datadir}/%{name}/bin

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr aop/output/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

# manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}
cp -pr aop/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}
install -m 644 aop/RELEASE_NOTES.txt $RPM_BUILD_ROOT%{_docdir}/%{name}



%if %{with_repolib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
	install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodir}/component-info.xml
	install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
	cp $RPM_BUILD_ROOT%{_javadir}/jboss-aop/jboss-aop.jar $RPM_BUILD_ROOT%{repodirlib}
	cp $RPM_BUILD_ROOT%{_javadir}/jboss-aop/jrockit-pluggable-instrumentor.jar $RPM_BUILD_ROOT%{repodirlib}
	cp $RPM_BUILD_ROOT%{_javadir}/jboss-aop/jboss-aop-jdk50-client.jar $RPM_BUILD_ROOT%{repodirlib}
	cp $RPM_BUILD_ROOT%{_javadir}/jboss-aop/pluggable-instrumentor.jar $RPM_BUILD_ROOT%{repodirlib}
	cp $RPM_BUILD_ROOT%{_javadir}/jboss-aop/jboss-aop-jdk50.jar $RPM_BUILD_ROOT%{repodirlib}
	cp $RPM_BUILD_ROOT%{_javadir}/jboss-aop/jdk14-pluggable-instrumentor.jar $RPM_BUILD_ROOT%{repodirlib}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi


%files
%defattr(0644,root,root,0755)
%{_javadir}/%{name}
%dir %{_datadir}/%{name}/bin
%attr(0755,root,root) %{_datadir}/%{name}/bin/*.sh

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}


%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{repodir}
%endif

%changelog
* Thu Aug 02 2007 Fernando Nasser <fnasser@redhat.com> - 0:1.5.0-0jpp.ep1.2.1
- Rebuild

* Mon Jul 16 2007 Deepak Bhole <dbhole@redhat.com> - 0:1.5.0-0jpp.ep1.2
- Fixed error in component info

* Mon Jul 16 2007 Deepak Bhole <dbhole@redhat.com> - 0:1.5.0-0jpp.ep1.1
- Upgrade to 1.5.5.GA

* Wed Jul 12 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.5.0-2jpp_1rh
- Merge with upstream

* Wed Jul 12 2006 Ralph Apel <r.apel at r-apel.de> 0:1.5.0-2jpp
- Drop link-in of jboss-profiler lib, don't BRequire it
- Drop java-javadoc BR
- Add Requires
- Drop commons/lib link-in

* Tue Jul 11 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.5.0-1jpp_1rh
- Merge with upstream
- Add missing BR for jboss-profiler

* Tue Jun 06 2006 Ralph Apel <r.apel at r-apel.de> 0:1.5.0-1jpp
- Upgrade to 1.5.0

* Fri May 19 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.3.6-1jpp_1rh
- Merge with upstream for upgrade
- Do not run tests: blocks on the first org.jboss.test.aop.basic.AOPTester

* Wed May 03 2006 Ralph Apel <r.apel at r-apel.de> 0:1.3.6-1jpp
- Upgrade to 1.3.6
- Doesn't include aspects-library any more, see standalone
  jboss-aspects, as well as bundled jboss4-aspects
- Provide/Obsolete jboss-aop-framework

* Thu Apr 13 2006 Ralph Apel <r.apel at r-apel.de> 0:1.3.1-3jpp
- First JPP-1.7 release
- Make jdk15 support optional

* Wed Nov 16 2005 Ralph Apel <r.apel at r-apel.de> 0:1.3.1-2jpp
- Patch to qdox-1.5
* Fri Aug 05 2005 Ralph Apel <r.apel at r-apel.de> 0:1.3.1-1jpp
- First standalone release
- option '--with frameworkonly' to prepare for build of 
  jboss4-cache and jboss4-console
